/*
 * DoublePendulum.h
 *
 *  Created on: 2009/03/24
 *      Author: sambuichi
 */

#ifndef DOUBLEPENDULUM_H_
#define DOUBLEPENDULUM_H_

#include "common.h"

#define N 4
#define meter_to_pixel 50.

class DoublePendulum {
public:
//	DoublePendulum(float, float);
	DoublePendulum();
	virtual ~DoublePendulum();

	void next();

	float getFirstRad();
	float secondRad();
	float firstAngleRate();
	float secondAngleRate();

	int *getPos();

private:

	void ODE_Def(double*,double*);
//	void Runge_Kutta_4(double*,double*);
	void Runge_Kutta_4(double*);
	void Gyaku_Gyoretsu(double[2][2]);
	void Draw_Pendulum(double[N]);

	float furiko_origin_x;
	float furiko_origin_y;

//	window_x_width 300        // Window ̕`̈̉
//	window_y_width 300        // Window ̕`̈̍
//	refresh_rate 50           // Aj[V̕`Ԋu(PʁF~b)
//	window_title "dUq" // Window ̃^Cg

	// dUq̃p[^[
	float m0;	// ̐Uq̎ [kg]
	float m1;	// ̐Uq̎ [kg]
	float l0;	// ̐Uq̒ [m]
	float l1;	// ̐Uq̒ [m]
	float g;	// d͉x [m/s^2]

	int pos[N];	//! pixel

	// V~[Ṽp[^[
//	float firstRad;			// x[0]: ̐Uq̊px [rad]
//	float secondRad;		// x[1]: ̐Uq̊px [rad]
//	float firstAngleRate;	// x[2]: ̐Uq̊px [rad/s]
//	float secondAngleRate;	// x[3]: ̐Uq̊px [rad/s]
	double x[N];

	float dt; 	// lϕ̎ԊԊu t
	float tend;	// Aj[V1R}̐ϕ

	// ̑̕ϐ
	int counter; // V~[V̐ϕXebṽJE^
	double t;       // (V~[V̐E)
};

#endif /* DOUBLEPENDULUM_H_ */
